;+
; **-pchkfile-check file string table entry
;
;   pchkfile "string",pcode
;
; inputs:
;   string = string base address (either in flash or seeprom)
;   pcode = address of pcode to be pcall''ed if string matches
;
; outputs:
;   does "pcall pcode" if URL file matches string then does "pret"
;-
.section .bss
    .global url_parms
url_parms:      .skip 2    ; 0 or offset to start of URL parms (after '?')

#define P1    (BP+0)
#define P2    (P1+2)
#define P3    (P2+2)

#define pchkfile_str   P1
#define pchkfile_pcode P2
#define pchkfile_temp  P3

.text
    .global pchkfile
pchkfile: pcode_routine   2|NO_P1_IND

    rcall pip_setup_r10r12reloc
    penter 0

#define DEBUG_PCHKFILE
#undef DEBUG_PCHKFILE
#ifdef DEBUG_PCHKFILE

#define putchar_serial pmovbi putc_b,0
#define putchar_net    pmovbi putc_b,1
#define serial_binary  pser_mode 1
#define serial_normal  pser_mode 0

    pmovbi putcok,1
    putchar_net
    putchar_serial                      ; switch putchar to serial port
    serial_binary                       ; put serial port in binary mode

    pprintv "pchkfile_str=",pchkfile_str
    pprintv "\r\n*pchkfile_str=",[pchkfile_str]
    pprint "\r\npchkfile_str="
    pprint [pchkfile_str]
    pcrlf
#endif

    pmovwi url_parms,[data_addr]    ; get data address (skip over "GET ")
    paddwi url_parms,4              ; GET /file?xxxxxxxxxxx
  ;;pprintv " before url_parms=",[url_parms]
  ;;pcrlf
    purl2scmp url_parms,[pchkfile_str]  ; compare strings
  ;;pprintv " after url_parms=",[url_parms]
  ;;pcrlf
    pjumpne pchkfile_nomatch        ; if no match then exit
  ;;pprint "[purl2scmp name matches]\r\n"

    pr2s pchkfile_temp,[url_parms],1 ; check last character in buffer
  ;;pprintv " pchkfile_temp=",[pchkfile_temp]
    pcmpbi pchkfile_temp,' '        ; bad if final character was not either
    pjumpeq pchkfile_match          ; ' '...or
    pcmpbi pchkfile_temp,'?'        ; '?'
    pjumpne pchkfile_nomatch        ; neither...show mismatch
    pincw url_parms                 ; must have been a '?'...fix pointer
pchkfile_match:

  ;;pprint "[purl2scmp full match]\r\n"

#ifdef CHECK_PORT_URL_PARMS
    pcall pchk_port_url_parms
#endif /* CHECK_PORT_URL_PARMS */

#ifdef DEBUG_PCHKFILE
    pprintv " pcode=",[pchkfile_pcode]
    pprint " [match]\r\n"
#endif

    ppushn putcok,1              ; save state of putcok flag
    pmovbi putcok,1              ; allow printing
    pmovbi putc_b,1              ; output to net
    pcall [pchkfile_pcode]       ; call passed pcode routine
    pmovbi putc_b,1              ; output to net
    ppopn putcok,1               ; restore state of putcok flag

#define PCODE_P (P3+4)
  ;;pserial_debug
  ;;pcrlf
  ;;pprintv "-----------------&P1=",P1
  ;;pprintv "P1=",[P1]
  ;;pprintv "",[P1+2]
  ;;pprintv "",[P1+4]
  ;;pprintv "",[P1+6]
  ;;pprintv "",[P1+8]
  ;;pprintv "",[P1+10]
  ;;pprintv "",[P1+12]
  ;;pprintv "",[P1+14]
  ;;pprintv "",[P1+16]
  ;;pprintv "",[P1+18]
  ;;pcrlf
  ;;pprintv "CODEP(pchkfile_pret)=",CODEP(pchkfile_pret)
    pmovwi pchkfile_temp,CODEP(pchkfile_pret)   ; execute "pret" on exit
  ;;pprintv " PCODE_P=",[PCODE_P]
  ;;pprintv " swapped PCODE_P=",[swap PCODE_P]
  ;;pprintv "PCODE_P=>",[pchkfile_temp]
  ;;pprintv " swaped PCODE_P=>",[swap pchkfile_temp]
    pmovwi PCODE_P,[swap pchkfile_temp]   ; this diverts pcode interpreter
  ;;pcrlf

    pjump pchkfile_exit

.global pchkfile_pret
pchkfile_pret:
#ifdef DEBUG_PCHKFILE
    pprint "at pchkfile_pret\r\n"
#endif
    pret              ; on match we come here after pretn

pchkfile_nomatch:
  ;;pprint "[purl2scmp mismatch]\r\n"
#ifdef DEBUG_PCHKFILE
    pprintv " pcode=",[pchkfile_pcode]
  ;;pprintv " swapped PCODE_P=",[swap PCODE_P]
    pprint " [nomatch]\r\n"
#endif
    pmovwi url_parms,0         ; zap offset to URL parameters

pchkfile_exit:
    pretn 0
