;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------
;+
; **-pprint-pcode print a string.
;
; inputs:
;   r10 -> string to print
;-
.text
    .global pprint
pprint: pcode_routine 1
    rjmp outstr_r10_nospace

    .global outstr_r10
outstr_r10:
    space
outstr_r10_nospace:
    pushw z
    rcall r10reloc
    movw z,r10
    tstbi zh,0x80               ; is this in serial EEPROM
    brne str_seeprom            ; sure enough
    mov r0,zl
    or r0,zh
    breq outstr_r10_done        ; zero pointer - dont write string
outstr_z:
    lpm
    adiw zl,1
    tst r0
    breq outstr_r10_done
    mov ch,r0
    rcall do_putchar
    rjmp outstr_z
outstr_r10_done:
    popw z
    ret
str_seeprom:
    andi zh,0x7f                ; clear seeprom flag
    movw y,z                    ; set seeprom address
str_seeprom_next:
    rcall import_seeprom_read          ; read next byte
    mov ch,i0
    tst ch
    breq outstr_r10_done
    rcall do_putchar
    rjmp str_seeprom_next
