;+
; **-pprintse-print n bytes from seeprom
;
; inputs:
;       r10 = string base address (in seeprom, >= 0x8000)
;       r12 = number of bytes to print (16-bit value)
;-
.text
    .global pprintse
pprintse: pcode_routine 2|NO_P1_IND
    movw r16,r12                ; count in r16
    movw y,r10                  ; y is seeprom address
    andi yh,0x7f                ; clear seeprom flag
    rjmp pprintse_chk           ; check 16-bit count
pprintse_next:
    pushw r16
    rcall import_seeprom_read   ; read next byte from SEEPROM
    mov ch,i0
    rcall do_putchar            ; output
    popw r16
    decw r16
pprintse_chk:
    tst r16l                    ; test low count byte
    brne pprintse_next          ; back for more if non-zero
    tst r16h                    ; test high count byte
    brne pprintse_next          ; back for more if non-zero
    ret

